/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 345 (Exercise B.1.8)
**
*/

new;
library rpb,pgraph;

cls;

let sigma = 0.25 0.20 0.15;
n = rows(sigma);
let rho =   1.00 
            0.50   1.00
            0.25   0.00   1.00;
rho = xpnd(rho);
call invpd(rho);

cov = rho .* sigma .* sigma';

print;
print "=====================  Question 4  =======================================";

SR = 0.50;

let x = 0.25 0.25 0.50;
sigma_x = sqrt(x'cov*x);
phi = SR/sigma_x;

mr = (cov * x)/sigma_x;
Pi_ = SR .* mr;
Pi_x = x'Pi_;
beta1 = mr/sigma_x;
beta2 = Pi_/Pi_x;

Results = 100*(x~mr~Pi_)~beta1~beta2|(error(0)~error(0)~100*Pi_x~error(0)~error(0));
print ftosa(Results,"%lf",3,2);

let x = 0.05 0.05 0.90;
sigma_x = sqrt(x'cov*x);
phi = SR/sigma_x;

mr = (cov * x)/sigma_x;
Pi_ = SR .* mr;
Pi_x = x'Pi_;
beta1 = mr/sigma_x;
beta2 = Pi_/Pi_x;

Results = 100*(x~mr~Pi_)~beta1~beta2|(error(0)~error(0)~100*Pi_x~error(0)~error(0));
print ftosa(Results,"%lf",3,2);

let x = 0.90 0.05 0.05;
sigma_x = sqrt(x'cov*x);
phi = SR/sigma_x;

mr = (cov * x)/sigma_x;
Pi_ = SR .* mr;
Pi_x = x'Pi_;
beta1 = mr/sigma_x;
beta2 = Pi_/Pi_x;

Results = 100*(x~mr~Pi_)~beta1~beta2|(error(0)~error(0)~100*Pi_x~error(0)~error(0));
print ftosa(Results,"%lf",3,2);

let x = 1.00 0.00 0.00;
sigma_x = sqrt(x'cov*x);
phi = SR/sigma_x;

mr = (cov * x)/sigma_x;
Pi_ = SR .* mr;
Pi_x = x'Pi_;
beta1 = mr/sigma_x;
beta2 = Pi_/Pi_x;

Results = 100*(x~mr~Pi_)~beta1~beta2|(error(0)~error(0)~100*Pi_x~error(0)~error(0));
print ftosa(Results,"%lf",3,2);

