/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 372 (Exercise B.3.9)
**
*/

new;
library rpb,pgraph;

cls;

let m_j[2,1] = 1.00
               0.50;
m = rows(m_j);

r = 0.02;

let mu =    0.05 0.06 0.08 0.06;
let sigma = 0.15 0.20 0.25 0.20;
n = rows(Sigma);
let rho =   1.00 
            0.10   1.00
            0.20   0.60   1.00
            0.40   0.50   0.50 1.00;
rho = xpnd(rho);
call invpd(rho);

cov = rho .* sigma .* sigma';

/*
**> Question 2
**
*/

print;
print "=====================  Question 2.a  =======================================";

A = ones(1,n); B = 1;
gamma_ = seqa(0,1/4000,10000);
Bounds = (-1e300~1e300) .* ones(n,1);

{x0,mu0,sigma0,gamma0,retcode} = Compute_MVO_Portfolio(mu,cov,A,B,0,0,Bounds,gamma_,0);  
SR = (mu0-r)./sigma0;
indx = maxindc(SR);
x0 = x0[.,indx]; 
mu0 = mu0[indx]; 
sigma0 = sigma0[indx]; 
gamma0 = gamma0[indx];
phi0 = 1/gamma0;

// Analytical solution

x_bar = invpd(cov)*(mu-r) / (ones(1,n) * invpd(cov)*(mu-r));
mu_bar = x_bar'mu; 
sigma_bar = sqrt(x_bar'*cov*x_bar); 
phi_bar = (ones(1,n) * invpd(cov)*(mu-r));

{x,u1,u2,u3,u4,retcode} = QProg(x_bar,cov,1/phi_bar*(mu-r),A,B,0,0,-1~1);

print "x = ";
print ftosa(seqa(1,1,n)~100*(x0~x_bar~x),"%lf",3,2);
print;
print "mu(x) / sigma(x) / phi(x) = ";
print ftosa((100*mu0|100*sigma0|phi0)~(100*mu_bar|100*sigma_bar|phi_bar),"%lf",3,4);
print;

e = eye(n);
beta_bar = (e'*cov*x_bar)/(x_bar'*cov*x_bar);
mu_beta_bar = beta_bar .* (mu_bar - r);
print "results = ";
print ftosa(seqa(1,1,n)~100*x_bar~100*(mu-r)~beta_bar~100*mu_beta_bar,"%lf",3,3);

print;
print "=====================  Question 2.b  =======================================";

C = -ones(1,n);
phi_tilde = phi_bar;
gamma_tilde = 1 / phi_tilde;
x_tilde_j = zeros(n,m);
lambda_tilde = zeros(m,1);

sv = ones(n,1)/n;

j = 1;
do until j > m;
  D = -m_j[j];
  {x_tilde_j[.,j],u1,u2,u3,u4,retcode} = QProg(sv,cov,gamma_tilde*mu,0,0,C,D,-1~1);
  lambda_tilde[j] = u2;
  j = j + 1;
endo;

print "lambda = ";
print ftosa(100*lambda_tilde,"%lf",3,4);
print;

x_tilde = meanc(x_tilde_j');
x_tilde = x_tilde/sumc(x_tilde);
mu_x_tilde = x_tilde'mu;
psi = sumc(lambda_tilde .* m_j);

print "x(tilde) = ";
print ftosa(seqa(1,1,n)~100*(x_tilde_j~x_tilde),"%lf",3,2);
print;
print ftos(100*mu_x_tilde,"mu(tilde) = %lf",3,4);
print;

beta_tilde = (e'*cov*x_tilde)/(x_tilde'*cov*x_tilde);
mu_beta_tilde = beta_tilde .* (mu_x_tilde - r);
alpha_tilde = psi * (1 - beta_tilde);

scale_alpha = (mu-r-mu_beta_tilde)/alpha_tilde;
alpha_tilde = scale_alpha * alpha_tilde;

print "results = ";
print ftosa(seqa(1,1,n)~100*(mu-r)~100*alpha_tilde~beta_tilde~100*mu_beta_tilde~100*(mu_beta_tilde+alpha_tilde),"%lf",3,2);