/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 35 (Figure 1.11)
**
*/

new;
library rpb,pgraph;

cls;

let lambda = 0.98 0.95 0.90;
alpha = 1-lambda;
n = 260;
w = zeros(n,3);

i = 1;
do until i > 3;
  w[.,i] = alpha[i] .* seqm(1,1-alpha[i],n);
  i = i + 1;
endo;

w = zeros(1,3) | w;
ws = cumsumc(w);
t = seqa(0,1,n+1);

w2 = 1 - (1-alpha')^seqa(0,1,n+1);

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1|3; _pcolor = 1|2|4; _plwidth = 10;
  xtics(0,250,50,2);
  ytics(0,100,20,2);
  _plegstr = "\202l\201 = 0.98\000\202l\201 = 0.95\000\202l\201 = 0.90";
  _plegctl = {2 6 5 2};
  xlabel("\216m");
  ylabel("\216W]m[ (in %)");
  graphprt("-c=1 -cf=chap1-2-1-4.eps");
  xy(t,100*ws);