/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 49 (Correlation matrix 1.23)
**
*/

new;
library rpb,pgraph;

cls;

PathName = "data\\";
datFileName = PathName $+ "equity-indices-weekly.dat";
Data = loadd(datFileName);
vnames = lower("" $+ getname(datFileName));

BeginDate = 20050101;
LastDate = 20111231;
Data = selif(Data,(Data[.,1] .>= BeginDate) .and (Data[.,1] .<= LastDate));

let string selected_names = "spx" "sxxe" "ukx" "tpx" "bovespa" "rts" "nifty" "hsi";
let Factors               = 1     1      1     1     2         2     2       2;

indx = indsav(selected_names,vnames);
Dates = Data[.,1];
x = Data[.,indx];
R = x ./ lag1(x) - 1.0;
R = packr(R);

{Omega,F} =  vcx_rmt(R);
stddev = sqrt(diag(Omega));
C = Omega ./ stddev ./ stddev';

print ftosa(miss(lowmat(C),0),"%lf",3,2);

