/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 53 (Table 1.9)
**
*/

new;
library rpb,pgraph;

cls;

let mu =    0.05 0.06 0.08 0.06;
let sigma = 0.15 0.20 0.25 0.30;
n = rows(Sigma);
let rho =   1.00 
            0.10   1.00
            0.40   0.70   1.00
            0.50   0.40   0.80 1.00;
rho = xpnd(rho);
call invpd(rho);

cov = rho .* sigma .* sigma';
A = diagrv(zeros(n,n),sigma^2);

x0 = ones(n,1)/n;

gamma_ = 0.5;

{x1,u1,u2,u3,u4,retcode} = Qprog(x0,cov,gamma_*mu,0,0,0,0,0);
{x2,u1,u2,u3,u4,retcode} = Qprog(x0,cov,gamma_*mu,ones(1,n),1,0,0,0);

lambda = 0.03; 

A = eye(n);
{x3,er,vol,retcode} =  Compute_Ridge_Portfolio(x0,mu,cov,0,0,0,0,0,gamma_,lambda,A,0);
{x4,er,vol,retcode} = Compute_Ridge_Portfolio(x0,mu,cov,0,0,0,0,0,gamma_,lambda,A,1);

A = ones(n,1);
{x5,er,vol,retcode} = Compute_Lasso_Portfolio(x0,mu,cov,0,0,0,0,0,gamma_,lambda,A,0);
{x6,er,vol,retcode} = Compute_Lasso_Portfolio(x0,mu,cov,0,0,0,0,0,gamma_,lambda,A,1);


print ftosa(100*(x1~x2~x3~x4~x5~x6),"%lf",3,2);


