/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 68 (Table 1.17)
**
*/

new;
library rpb,pgraph;
cls;

let mu =    0.05 0.06 0.08 0.06;
let _sigma_ = 0.15 0.20 0.25 0.30;
n = rows(_Sigma_);
let rho =   1.00 
            0.10   1.00
            0.40   0.70   1.00
            0.50   0.40   0.80 1.00;
rho = xpnd(rho);
call invpd(rho);

Sigma = rho .* _sigma_ .* _sigma_';

print ftosa(100*(_sigma_~rho),"%lf",5,2);
print "--------------------------------------------------------------------------------------------------------";

A = ones(1,n); B = 1; 

{x_star,sigma_star,retcode} = Compute_MV_Portfolio(Sigma,A,B,0,0,-10~10);
{x_tilde,Sigma_tilde,lambda} = Shrinkage_JM_MV(Sigma,0.10~1.00);
{x_bar,sigma_bar,retcode} = Compute_MV_Portfolio(Sigma_tilde,A,B,0,0,-10~10);

results = x_star~x_tilde~x_bar;
print ftosa(100*results,"%lf",5,3);
print "--------------------------------------------------------------------------------------------------------";

_sigma_tilde = sqrt(diag(Sigma_tilde));
rho_tilde = Sigma_tilde ./ _sigma_tilde ./ _sigma_tilde';

print ftosa(100*(x_tilde~lambda),"%lf",5,3)$~ftosa(100*(_sigma_tilde~rho_tilde),"%lf",5,2);
print "--------------------------------------------------------------------------------------------------------";

vol_star = sqrt(x_star'Sigma*x_star);
vol_tilde = sqrt(x_tilde'Sigma*x_tilde);

print;
print /flush ftosa(100*(vol_star~vol_tilde),"%lf",3,2);

