/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Pages 81 & 82 (Tables 2.2, 2.3 & 2.4)
**
*/

new;
library rpb,pgraph;

cls;

let mu = 0.00 0.00 0.00;
let sigma = 0.30 0.20 0.15;
let rho = 1.00
          0.80 1.00
          0.50 0.30 1.00;
rho = xpnd(rho);
cov = rho .* sigma .* sigma';

let x = 0.50 0.20 0.30;

{risk,mr,rc,prc} = Compute_RC_Vol(x,cov);
result1 = (x~mr~rc~prc)|(error(0)~error(0)~risk~error(0));

alpha = 0.99;
{risk,mr,rc,prc} = Compute_RC_VaR(x,mu,cov,alpha);
result2 = (x~mr~rc~prc)|(error(0)~error(0)~risk~error(0));

{risk,mr,rc,prc} = Compute_RC_ES(x,mu,cov,alpha);
result3 = (x~mr~rc~prc)|(error(0)~error(0)~risk~error(0));

print "cov = ";
print ftosa(100*cov,"%lf",3,2);

var = 0.50^2*0.09 + 0.20^2*0.04 + 0.30^2*0.0225 +
      2*0.50*0.20*0.0480 +
      2*0.50*0.30*0.0225 +
      2*0.20*0.30*0.0090 ;
print ftos(100*var,"var = %lf",3,4);
vol = sqrt(var);
print ftos(100*vol,"vol = %lf",3,4);
Sx = cov*x;
print "Sigma*x =";
print ftosa(100*Sx,"%lf",3,4);
mr = Sx/vol;
print "Sigma*x / vol =";
print ftosa(100*mr,"%lf",3,4);
rc = x .* mr;
print "x * mr =";
print ftosa(100*rc,"%lf",3,4);

print "------------------------------------------";

print ftosa(100*result1,"%lf",3,2);

print ftosa(100*result2,"%lf",3,2);

print ftosa(100*result3,"%lf",3,2);

print "------------------------------------------";

