/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 123 (Table 2.21)
**
*/

new;
library rpb,pgraph;

cls;

let sigma = 0.15 0.20 0.30 0.10;
let rho = 1.00
          0.50  1.00
          0.00  0.20 1.00 
         -0.10  0.40 0.70 1.00;
rho = xpnd(rho);
cov = rho .* sigma .* sigma';
call invpd(cov);

{x,vol,mr,rc,prc} = Compute_ERC_Portfolio(0,cov);
beta = (cov*x)/(x'cov*x);
result  = 100*(x~mr~beta/100~rc~prc) |
          100*(error(0)~error(0)~error(0)~vol~error(0));

print ftosa(result,"%lf",3,2);
