/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 171 (Table 3.5)
**
*/

new;
library rpb,pgraph;

rndseed 123;

let sigma = 0.20 0.10 0.20 0.25;
let rho =   1.00
            0.80 1.00
            0.40 0.30  1.00
            0.30 0.10 -0.10 1.00;
rho = xpnd(rho);
cov = rho .* sigma .* sigma';
call invpd(cov);

n = rows(cov);

{x1,vol1,mr,rc,prc} = Compute_MDP_Portfolio(0,cov,-1);
DR1 = Diversification_Ratio(x1,cov);
rho1 = (eye(4)*cov*x1)./sigma./vol1;

{x2,vol2,mr,rc,prc} = Compute_MDP_Portfolio(0,cov,0);
DR2 = Diversification_Ratio(x2,cov);
rho2 = (eye(4)*cov*x2)./sigma./vol2;

cls;

print /flush ftos(100*vol1,"vol = %lf",3,2);
print /flush ftos(DR1,"DR = %lf",3,2);

print /flush ftos(100*vol2,"vol = %lf",3,2);
print /flush ftos(DR2,"DR = %lf",3,2);

print /flush ftosa(100*(x1~rho1~x2~rho2),"%lf",3,2);

