/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 277 (Tests the analytical formula of the implied risk premium)
**
*/

new;
library rpb,pgraph;

cls;

x = seqa(0,0.1,11);
x[9] = x[9] + 0.0001;
n = rows(x);
SR = 0.25;

sigma1 = 0.20; 
sigma2 = 0.80; 
rho = -1.0;

cov = (sigma1^2 ~ rho*sigma1*sigma2) |
      (rho*sigma1*sigma2 ~ sigma2^2) ;

pi1 = zeros(n,2);
pi2 = zeros(n,2);

i = 1;
do until i > n;
  w = x[i]|(1-x[i]);
  {vol,mr,rc,prc} = Compute_Risk_Contribution(w,cov);
  pi1[i,.] = SR * mr';
  i = i + 1;
endo;

{y1,y2} = Implied_Risk_Premium2(x,sigma1,sigma2,rho,SR);
pi2 = y1~y2;

print ftosa(x~pi1~pi2~(pi1-pi2),"%lf",5,4);

